/*
    util.h
    $Id: util.h,v 1.12 2014/12/19 17:01:30 daichi Exp $

 */
#ifndef PCFG_UTIL_H
#define PCFG_UTIL_H
#include <cstdarg>
#include <vector>
#include <string>
#include <utility>
#include <tr1/unordered_map>
#define	 inf		(1.0/0.0)
#define  cons		make_pair
#define  hash_map	tr1::unordered_map

using namespace std;

typedef pair<int,int> tuple;

double poch (double alpha, int n);
double logsumexp (double x, double y, int init = 0);
char *strconcat (const char *s, const char *t);
vector<string> parse_line (string &line);
int ntypes (vector<vector<int> > &data);
int eprintf (const char *fmt, ...);
int error (const char *fmt, ...);


#endif
