/*
    dict.h
    $Id: dict.h,v 1.3 2014/11/29 00:20:05 daichi Exp $

*/
#ifndef PCFG_DICT_H
#define PCFG_DICT_H
#include <string>
#include "util.h"

using namespace std;

struct dictionary {
	
	hash_map<string,int> hash;
	hash_map<int,string> rhash;
	int seed;

	int id (string &s);
	string word (int w);
	int size ();
	void print ();
	void save (char *file);

	dictionary () { seed = 0; }

};




#endif
