/*
    gamma.h
    header file for digamma and trigamma functions.
    $Id: gamma.h,v 1.1 2014/12/17 15:00:28 daichi Exp $

*/
#ifndef __GAMMA_H__
#define __GAMMA_H__
#ifdef __cplusplus
extern "C" {
#endif

double digamma(double x);
double trigamma(double x);
double gammaln(double x);

#define psi(x)	digamma(x)
#define ppsi(x)	trigamma(x)
#define lgamma(x) gammaln(x)

#ifdef __cplusplus
}
#endif
#endif
